%global python3_pkgversion 38
%global python3_other_pkgversion 3

# Created by pyp2rpm-3.3.3
%global pypi_name gunicorn

# Our EL8 buildroots default to Python 3.8, but let's also build 3.6, just to be safe
# to make dnf happy
%if 0%{?rhel} == 8
%bcond_without python36
%else
%bcond_with python36
%endif

Name:           python-%{pypi_name}
Version:        20.1.0
Release:        7%{?dist}
Summary:        WSGI HTTP Server for UNIX

License:        MIT
URL:            https://gunicorn.org
Source0:        https://files.pythonhosted.org/packages/source/g/%{pypi_name}/%{pypi_name}-%{version}.tar.gz
BuildArch:      noarch

BuildRequires:  python%{python3_pkgversion}-rpm-macros
BuildRequires:  python%{python3_pkgversion}-devel
BuildRequires:  python%{python3_pkgversion}-setuptools


%description
%{summary}


%package -n     python%{python3_pkgversion}-%{pypi_name}
Summary:        %{summary}
%{?python_provide:%python_provide python%{python3_pkgversion}-%{pypi_name}}
Obsoletes:      python%{python3_other_pkgversion}-%{pypi_name} < %{version}-%{release}
Requires:       python%{python3_pkgversion}-setuptools >= 3.0


%description -n python%{python3_pkgversion}-%{pypi_name}
%{summary}

%if %{with python36}
%package -n     python%{python3_other_pkgversion}-%{pypi_name}
Summary:        %{summary}
%{?python_provide:%python_provide python%{python3_other_pkgversion}-%{pypi_name}}

BuildRequires:  python36-devel
BuildRequires:  python%{python3_other_pkgversion}-setuptools
Requires:       python%{python3_other_pkgversion}-setuptools

%description -n python%{python3_other_pkgversion}-%{pypi_name}
%{summary}
%endif

%prep
set -ex
%autosetup -n %{pypi_name}-%{version}
# Remove bundled egg-info
rm -rf %{pypi_name}.egg-info


%build
set -ex
%py3_build
%if %{with python36}
/usr/bin/python3.6 setup.py build '--executable=/usr/bin/python3.6 -s'
%endif


%install
set -ex
%py3_install
mv %{buildroot}/usr/bin/gunicorn %{buildroot}/usr/bin/gunicorn-py38
%if %{with python36}
/usr/bin/python3.6 setup.py install --skip-build --root %{buildroot}
mv %{buildroot}/usr/bin/gunicorn %{buildroot}/usr/bin/gunicorn-py36
%endif


%files -n python%{python3_pkgversion}-%{pypi_name}
%license LICENSE
%doc docs/README.rst README.rst
%{_bindir}/gunicorn-py38
%{python3_sitelib}/%{pypi_name}
%{python3_sitelib}/%{pypi_name}-%{version}-py%{python3_version}.egg-info

%if %{with python36}
%files -n python%{python3_other_pkgversion}-%{pypi_name}
%license LICENSE
%doc docs/README.rst README.rst
%{_bindir}/gunicorn-py36
%{_prefix}/lib/python3.6/site-packages/%{pypi_name}
%{_prefix}/lib/python3.6/site-packages/%{pypi_name}-%{version}-py*.egg-info
%endif

%posttrans -n python%{python3_pkgversion}-%{pypi_name}
ln -sf %{_bindir}/gunicorn-py38 %{_bindir}/gunicorn

%postun -n python%{python3_pkgversion}-%{pypi_name}
rm -f %{_bindir}/gunicorn


%if %{with python36}
%posttrans -n python%{python3_other_pkgversion}-%{pypi_name}
ln -sf %{_bindir}/gunicorn-py36 %{_bindir}/gunicorn

%postun -n python%{python3_other_pkgversion}-%{pypi_name}
rm -f %{_bindir}/gunicorn
%endif

%changelog
* Tue Apr  5 2022 Sebastian Skracic <sskracic@redhat.com> - 20.1.0-7
- Ensuring python scripts for 3.6 and 3.8 use their respective interpreters

* Tue Apr  5 2022 Sebastian Skracic <sskracic@redhat.com> - 20.1.0-6
- Now building RPMs for both Python 3.6 and 3.8

* Wed Sep 29 2021 Evgeni Golov - 20.1.0-3
- Obsolete the old Python 3.6 package for smooth upgrade

* Mon Sep 06 2021 Evgeni Golov - 20.1.0-2
- Build against Python 3.8

* Fri Jun 11 2021 Evgeni Golov 20.1.0-1
- Update to 20.1.0

* Fri Feb 28 2020 Zach Huntington-Meath <zhunting@redhat.com> - 20.0.4-2
- Bump release to build for el8

* Fri Dec 13 2019 Evgeni Golov 20.0.4-1
- Update to 20.0.4

* Mon Nov 18 2019 Evgeni Golov - 20.0.0-1
- Initial package.
